$( window ).load(function() {
	
	var utils = (function(){
		return {
			drawList : function(list){
					var i;
					var result = [];
					for(i = 0; i < list.length; i++){
						result.push("<li>",list[i],"</li>");
					}
					
					return ["<ul>",result.join(""),"</ul>"].join("");
			}
		};
	})();
	
	var creditsHandler = (function(){
		var draw = function(){
			//$("#game").html("<div class=\"creditsScreen\"><div class=\"elements\">"+utils.drawList(credits)+"</div></div>");
			$("#game").html("<div class=\"creditsScreen\"></div>");
			$("#game .creditsScreen").addClass("creditAnimation");
			var position = 0;
			var stopAnimation = false;
			var animationTimeout = null;
			audioHandler.init();
			audioHandler.playOnce("credits");
			var animate = function(time){
				if(stopAnimation) return;
				animationTimeout = window.setTimeout(toggleClasses,time);
			};
			var toggleClasses = function(i){
				position++;
				if(position == 0){
					$("#game .creditsScreen").removeClass("lieu").removeClass("theme")
				}
				if(position == 1){
					$("#game .creditsScreen").addClass("lieu");
				}
				if(position == 2){
					$("#game .creditsScreen").addClass("theme");
				}
				if(position == 3){ // Exit
					audioHandler.stop();
					endCallBack();
					return;
				}
				animate(4000);
			};
			animate(5000);
			
			/* animation*/
			
			
			$("#game").find(".creditsScreen").on("click",function(){
				window.clearTimeout(animationTimeout);
				stopAnimation = true;
				audioHandler.stop();
				$(this).remove();
				endCallBack();
				});
		};
		
		return {
			launch : function(){
				draw();
				return {
					after : function(callback) {
						endCallBack = callback;
					}
				}
			}
		};
	})();
	
	var gameHandler = (function(){
		var $content = null;
		var progression = 0;
		var userPath = [];
		var endCallBack = null;
		var pathDetectorCtx;
		var endOfGame = false;
		
		var init = function(){
			endOfGame = false;
			endCallBack = null;
			progression = 0;
			userPath = [];
			drawGame();
			timeHandler.launch(drawTimeOut);
			$content = $("#game .content");
			pathDetectorCtx = $("#game canvas.imageMap")[0].getContext('2d');
			$("#game canvas.imageMap").on("click",function(e){
				userClick(e);
			});
			
			drawScene();
		};
		var clearDetection = function(){
			pathDetectorCtx.clearRect(0, 0, pathDetectorCtx.canvas.width,
                    pathDetectorCtx.canvas.height);
		};
		var startDetection =function(data){
			var poly = data;
			//var poly=[ 5,5, 100,50, 50,100, 10,90 ];

			var ctx = pathDetectorCtx;
			//ctx.fillStyle = '#f00';
			//ctx.globalAlpha = 0.3;
			ctx.beginPath();
			ctx.moveTo(poly[0], poly[1]);
			for( item=2 ; item < poly.length-1 ; item+=2 ){ctx.lineTo( poly[item] , poly[item+1] )}

			ctx.closePath();
			//ctx.fill();
		};
		
		var generateImageMap = function() {
			return "<canvas class=\"imageMap\" width=\"1100px\" height=\"800px\"></canvas>";
		};
		
		var drawGame = function(){
			$("#game").html(generateImageMap()+"<div class=\"content\"><div class=\"timer\">0:00</div></div></div>");
		};
		/**
		 * Draw all elements of the game
		 */
		var drawQuestion = function(){
			// Draw the current progression
			// draw question
			var generateResponses = function(){
				return utils.drawList(questions[progression].responses);
			};
			var enigmeImage = "";
			if(questions[progression].enigmeImage){
				enigmeImage = "<div class=\"enigmeImage "+questions[progression].enigmeImage+"\"></div>";
			}
			
			$content.append("<div class=\"enigme\"><div class=\"question\">"+questions[progression].question+"</div><div class=\"responses\">"+generateResponses()+"</div></div>"+enigmeImage);
			// draw all responses
			// assign them a click
			$content.find(".enigme .responses").on("click",function(e){
				var questionIndex = $(e.target).parent().find("li").index(e.target);
				userRespond(questionIndex);
				return false;
			});
		};
		var isSuccess = function() {
			for(var i = 0; i < userPath.length;i++){
				if(userPath[i] !== thePath[i]){return false;}
			}
			return true;
		};
		
		var drawTimeOut = function(){
			$content.find(".enigme, .enigmeImage").remove();
			$content.off("click"); // no more questions
			$content.find(".timer").addClass("megaZoomFade");
			
			// todo add sound police
			
			audioHandler.playOnce("siren");
			
			window.setTimeout(function(){
				drawFinalScene();
			}, 3000);
		};
		
		var drawFinalScene = function(){
			timeHandler.stop();
			
			$content.attr("class","content");
			$content.find(".timer:not(.megaZoomFade)").remove();
			
			$content.append("<div class=\"finish button\">restart</div>");
			var finalCssClass = progression !== questions.length ? "final_late" : (isSuccess() ? "final_success" : "final_wrong");
			
			// add finla sounds
			if(finalCssClass === "final_success"){
				audioHandler.init();
				audioHandler.playOnce("success");
			} else {
				audioHandler.init();
				audioHandler.playOnce("ratee");
			}
			
			$content.addClass(finalCssClass);
			
			$content.find(".button").on("click",function(){
				audioHandler.stop();
				$content.remove();
				endCallBack();
			});
		};
		
		var drawScene = function(){
			$content.find(".enigme, .enigmeImage").remove();
			// todo scene change
			if(progression == questions.length){
				// to final
				$content.off("click"); // no more questions
				drawFinalScene();
			} else {
				clearDetection();
				$content.addClass(questions[progression].image);
				startDetection(questions[progression].object);
				audioHandler.addLayer(questions[progression].audio);
			}
		};
		
		
		var clickInObject = function(evt){
			var x = evt.clientX - $content[0].offsetLeft;
			var y = evt.clientY - $content[0].offsetTop;
			
			return pathDetectorCtx.isPointInPath(x, y) && !endOfGame;
		};
		/** debug only * /
		var paths = [];
		var temp=null;
		$(document).on("keypress",function(e){
			clearDetection();
			if(temp === null){
			paths = [];
				temp = clickInObject;
				clickInObject = clickInObject_debug;
				startDetection(paths);
			} else {
				clickInObject = temp;
				temp = null;
				startDetection(questions[progression].object);

			}
		});
		clickInObject_debug = function(evt){
			var x = evt.clientX - $content[0].offsetLeft;
			var y = evt.clientY - $content[0].offsetTop;
			
			paths.push(x,y);
			console.log(paths);
			
			clearDetection();
			startDetection(paths);
			
			return false;//pathDetectorCtx.isPointInPath(x, y);
		};// */
		
		var userRespond = function(index){
			progression++;
			audioHandler.playOnce("clic");
			drawScene();
			userPath.push(index);
			questionOpened = false;
		};
		
		var questionOpened = false;
		
		var userClick = function(e){
			if(questionOpened) return;
			if(clickInObject(e)){
				audioHandler.playOnce("clic");
				questionOpened = true;
				drawQuestion();
			}
		};
		
		return {
			launch : function(){
				init();
				return {
					after : function(callback) {
						endCallBack = callback;
					}
				}
			},
			off:function(){
				$content.remove();
			}
		};
	})();
	
	
	
	var start = function(){
		if($("#game .start").hasClass("clicked")) {return;}
		$("#game .start").addClass("clicked");
		audioHandler.playOnce("gun");
		window.setTimeout(function(){
			gameHandler.launch().after(toTitle);
		}, 3500);
	};
	
	var toCredits = function(){
		if($("#game .start").hasClass("clicked")) {return;}
		creditsHandler.launch().after(toTitle);
	};
	
	var toTitle = function(){
		drawTitle();
		audioHandler.init();
		audioHandler.addLayer({index:"l1",type:"stack"});
	};
	
	var drawTitle = function(){
		$("#game").html("<div class=\"title\"><div class=\"text\">"+title.text+"</div>" +
				"<div class=\"start button\">"+title.start+"</div>"+"<div class=\"credits button\">"+title.credits+"</div></div>");
		$("#game .start").bind("click",start);
		$("#game .credits").bind("click",toCredits);
	};
	
	preload(function(){
		$("#game").removeClass("loading");
		toTitle();
	});
});